{$PACKRECORDS 1}
{
Copyright (c) 1988 TurboPower Software
May be used freely as long as due credit is given
Version 1.1 - 3/15/89
  save and restore EMS page map
Version 1.2 - 3/29/89
  add more compiler directives (far calls off, boolean short-circuiting)
  add UseEmsIfAvailable to disable EMS usage when desired
}

{$R-,S-,F-,O-,I-,B-}

unit ExecSwap;
  {-Memory-efficient DOS EXEC call}
interface
 
function ExecWithSwap(Path, CmdLine : String) : Word;
  {-DOS EXEC supporting swap to EMS or disk}

function InitExecSwap(LastToSave : Pointer; SwapFileName : String) : Boolean;
  {-Initialize for swapping, returning TRUE if successful}

procedure ShutdownExecSwap;
  {-Deallocate swap area}

function EmsInstalled : Boolean;
function EmsPageFrame : Word;
function AllocateEmsPages(NumPages : Word) : Word;
procedure DeallocateEmsHandle(Handle : Word);

implementation

uses DOS;

  function ExecWithSwap(Path, CmdLine : String) : Word;
  begin
  	Exec(Path, CmdLine);
	ExecWithSwap:=DosExitCode;
  end;
  

  function InitExecSwap(LastToSave : Pointer;
                        SwapFileName : String) : Boolean;
  begin
    InitExecSwap := True;
  end;

  procedure ShutdownExecSwap;
  begin
  end;

  function EmsInstalled : Boolean;
  begin
    EmsInstalled:=false;
  end;

  function EmsPageFrame : Word;
  begin
    EmsPageFrame:=0;
  end;

  function AllocateEmsPages(NumPages : Word) : Word;
  begin
	AllocateEmsPages:=0;
  end;
  
  procedure DeallocateEmsHandle(Handle : Word);
  begin
  end;

end.
